"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class SampleVariantStats(ProtocolElement):
    """
    No documentation
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "depthCount",
        "filterCount",
        "heterozygosityRate",
        "id",
        "indelLengthCount",
        "qualityAvg",
        "qualityStdDev",
        "tiTvRatio",
        "variantCount",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import opencb as opencb_2_9_3

        return {
            "depthCount": opencb_2_9_3.DepthCount,
            "indelLengthCount": opencb_2_9_3.IndelLength,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_8_7 import opencb as opencb_2_9_3

        return {
            "org.opencb.biodata.models.variant.metadata.DepthCount": opencb_2_9_3.DepthCount,
            "org.opencb.biodata.models.variant.metadata.IndelLength": opencb_2_9_3.IndelLength,
            "org.opencb.biodata.models.variant.metadata.SampleVariantStats": opencb_2_9_3.SampleVariantStats,
        }

    __slots__ = [
        "depthCount",
        "filterCount",
        "heterozygosityRate",
        "id",
        "indelLengthCount",
        "qualityAvg",
        "qualityStdDev",
        "tiTvRatio",
        "variantCount",
        "biotypeCount",
        "chromosomeCount",
        "clinicalSignificanceCount",
        "consequenceTypeCount",
        "genotypeCount",
        "mendelianErrorCount",
        "typeCount",
    ]

    def __init__(
        self,
        depthCount,
        filterCount,
        heterozygosityRate,
        id,
        indelLengthCount,
        qualityAvg,
        qualityStdDev,
        tiTvRatio,
        variantCount,
        biotypeCount=dict,
        chromosomeCount=dict,
        clinicalSignificanceCount=dict,
        consequenceTypeCount=dict,
        genotypeCount=dict,
        mendelianErrorCount=dict,
        typeCount=dict,
        validate=None,
        **kwargs
    ):
        """Initialise the opencb_2_9_3.SampleVariantStats model.

        :param depthCount:
        :type depthCount: DepthCount
        :param filterCount:
            * The number of occurrences for each FILTER value in files from this
            set.          * Each file can contain more than one filter
            value (usually separated by ';').          *
        :type filterCount: dict[str, int]
        :param heterozygosityRate:
            * Heterozygosity rate as defined by PLINK: (N O)/N          *
            * N is the number of non-missing genotypes          * O is
            the observed number of homozygous genotypes for a given
            individual          *
        :type heterozygosityRate: float
        :param id:
            Sample identifier *
        :type id: str
        :param indelLengthCount:
            Indel length grouped in ranges *
        :type indelLengthCount: IndelLength
        :param qualityAvg:
            Mean Quality for all the variants with quality
        :type qualityAvg: float
        :param qualityStdDev:
            Standard Deviation of the quality
        :type qualityStdDev: float
        :param tiTvRatio:
            TiTvRatio = num. transitions / num. transversions
        :type tiTvRatio: float
        :param variantCount:
            Number of variants where the sample has the main allele (i.e. 0/1,
            1/1, ./1, 1/2, ...)
        :type variantCount: int
        :param biotypeCount:
            * Variants count group by biotype. e.g. protein-coding, miRNA, lncRNA,
            ...          * Each counter is increased at most one per
            variant. If multiple overlapping genes have the same
            biotypes, it will count as one.
        :type biotypeCount: dict[str, int]
        :param chromosomeCount:
            Number of variants per chromosome *
        :type chromosomeCount: dict[str, int]
        :param clinicalSignificanceCount:
            * Variants count group by clinical significance. e.g. benign,
            likely_benign, likely_pathogenic, pathogenic,
            uncertain_significance  ...          * Each counter is
            increased at most one per variant. If multiple variant
            traits have the same clinical significance, it will count
            as one.
        :type clinicalSignificanceCount: dict[str, int]
        :param consequenceTypeCount:
            * Variants count group by consequence type. e.g. missense_variant,
            synonymous_variant, stop_lost, ...          * Each counter
            is increased at most one per variant. If multiple
            overlapping transcripts have the same consequence type, it
            will count as one.
        :type consequenceTypeCount: dict[str, int]
        :param genotypeCount:
            Number of variants per genotype. Only counts genotypes with the main
            allele. Phase is ignored. *
        :type genotypeCount: dict[str, int]
        :param mendelianErrorCount:
            Number of mendelian errors grouped by PLINK error codes grouped by
            Chromosome. *
        :type mendelianErrorCount: dict[str, dict[str, int]]
        :param typeCount:
            Variants count group by type. e.g. SNP, INDEL, MNP, SNV, ...
        :type typeCount: dict[str, int]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "2.9.3-GEL"
